## mingw-w64-opencsg-1.8.2-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)
project(OpenCSG LANGUAGES CXX VERSION 1.8.2)

option(BUILD_EXAMPLE "Build example program" ON)
option(BUILD_SHARED_LIBS "Build using shared libraries" ON)

include(GNUInstallDirs)

add_subdirectory(src)
if(BUILD_EXAMPLE)
    add_subdirectory(example)
endif()

=== example/CMakeLists.txt ===
add_executable(opencsgexample WIN32 MACOSX_BUNDLE
    displaylistPrimitive.cpp displaylistPrimitive.h
    includeGl.h
    main.cpp
)

find_package(OpenGL REQUIRED)
find_package(GLUT REQUIRED)

target_include_directories(opencsgexample PRIVATE
    "${CMAKE_SOURCE_DIR}/include"
)

target_link_libraries(opencsgexample PRIVATE
    opencsg
    ${OPENGL_LIBRARIES}
    ${GLUT_LIBRARIES}
)

install(TARGETS opencsgexample
    BUNDLE DESTINATION ${CMAKE_INSTALL_PREFIX}/Applications
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=opencsg
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.8.2
pkgrel=1
pkgdesc="Library for image-based CSG rendering using OpenGL (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
license=('spdx:GPL-2.0-or-later')
url="http://www.opencsg.org"
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
options=(!strip !buildflags)
source=("http://www.opencsg.org/OpenCSG-${pkgver}.tar.gz")
sha256sums=('5ac5df73b1ad3340dd6705ff90e009f1a946bb9536c21c2263a6f974265664c0')

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=OFF \
      -DBUILD_EXAMPLE=OFF \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}-static"

  cmake --build "build-${MSYSTEM}-static"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DBUILD_EXAMPLE=OFF \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}-shared"

  cmake --build "build-${MSYSTEM}-shared"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}-static"

  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}-shared"

  cd "${srcdir}/${_realname}-${pkgver}"

  install -Dm644 -t "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/" \
    doc/license/gpl-2.0.txt \
    doc/license/gpl-3.0.txt
}
